#define BIT7 0x80
#define BIT6 0x40
#define BIT5 0x20
#define BIT4 0x10
#define BIT3 0x08
#define BIT2 0x04
#define BIT1 0x02
#define BIT0 0x01

#define HIGH 1
#define LOW 0

#define TRUE 1
#define FALSE 0

#define SET 1
#define CLEARED 0

#define LOWBYTE(v)   ((unsigned char) (v))
#define HIGHBYTE(v)  ((unsigned char) (((unsigned int) (v)) >> 8))

//SFRs
#define TIMER2_PAGE 0
#define SPI0_PAGE 0
#define CAPSENSE_PAGE 0
sfr16 CS0D = 0xED;

//ASCII
#define ASCII_CR 13
#define ASCII_NULL 0

//LCD
#define DIGIT_HEIGHT_PIX 30
#define DIGIT_WIDTH_PIX 24
#define DIGIT_WIDTH_BYTE (DIGIT_WIDTH_PIX/8)
#define DIGIT_PIXDATA_ARRAY_LEN (DIGIT_HEIGHT_PIX*DIGIT_WIDTH_BYTE)
#define NUM_LINE_DATA_BYTES 16
#define LCDMODE_ALLCLEAR BIT5
#define LCDMODE_DATAUPDATE BIT7
#define ANGLE 1
#define DELTAS 0
#define ANGLE_DISP 4

//capacitive touch sense
#define SENSOR_1 1
#define SENSOR_1_CHANNEL 2
#define SENSOR_2 2
#define SENSOR_2_CHANNEL 3
#define SENSOR_3 3
#define SENSOR_3_CHANNEL 13
#define TOUCH_DELTA_THRESHOLD 2000
#define UPPER_MIDDLE 1
#define LOWER_LEFT 2
#define LOWER_RIGHT 3

//global variables shared across files
extern code unsigned char LCD_Char0[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char1[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char2[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char3[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char4[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char5[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char6[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char7[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char8[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Char9[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCD_Error[DIGIT_PIXDATA_ARRAY_LEN];
extern code unsigned char LCDLineAddr_LUT[];
extern bit DISPLAY_ANGLE_OR_DELTAS;
extern bit NEED_TO_CLEAR_SCREEN;

//function prototypes
void Delay_us(unsigned int DelayCount);
void Delay_10ms(unsigned int DelayCount);
void Delay_seconds(unsigned int DelayCount);
void Update_LCD(unsigned char SensorNumber, unsigned long DisplayValue);
void LCD_Clear_All();
void Write_One_Dummy_Byte(void);
void Write_Two_Dummy_Bytes(void);
unsigned char* Match_Digit_to_Array(unsigned char InputDigit);
unsigned int Measure_Capacitance(unsigned char SensorNumber);
unsigned char Find_Minimum(unsigned int Sensor1, unsigned int Sensor2, unsigned int Sensor3);

//port pins
sbit EFM_DISP_ENABLE = P2^7;
sbit SPI_CS = P0^1;
sbit DEBUG_PIN = P0^4;
sbit PUSHBUTTON_0 = P1^2;
